package.preload['common.c4_driver_declarations']=(function(...)
TEMPLATE_VERSION={}
TEMPLATE_VERSION.c4_driver_declarations="2014.10.31"
EX_CMD={}
PRX_CMD={}
NOTIFY={}
DEV_MSG={}
LUA_ACTION={}
ON_DRIVER_INIT={}
ON_DRIVER_EARLY_INIT={}
ON_DRIVER_LATEINIT={}
ON_DRIVER_DESTROYED={}
ON_PROPERTY_CHANGED={}
DEFAULT_PROXY_BINDINGID=5001 end)
package.preload['common.c4_common']=(function(...)
require"common.c4_driver_declarations"
require"lib.c4_log"
require"lib.c4_timer"
LOG={}
function ON_DRIVER_EARLY_INIT.c4_common()
print("Creating LOG")
print("test2")
LOG=c4_log:create("Template_c4z Change Name")
print("Done Creating LOG")
print(LOG,LOG.Print)
end
function ON_DRIVER_INIT.c4_common()
gC4LogTimer=c4_timer:create("Log Timer",45,"MINUTES",OnLogTimerExpired)
end
function OnLogTimerExpired()
LogWarn("Turning Log Mode Off (timer expired)")
gC4LogTimer:KillTimer()
C4:UpdateProperty("Log Mode","Off")
OnPropertyChanged("Log Mode")
end
gForceLogging=false
function ON_PROPERTY_CHANGED.Debug(e)
gC4LogTimer:KillTimer()
if(gForceLogging)then
LOG:OutputPrint(true)
LOG:OutputC4Log(true)
else
LOG:OutputPrint(e=="On")
LOG:OutputC4Log(false)
if(e=="Off")then
return
end
gC4LogTimer:StartTimer()
end
end
end)
package.preload['common.c4_init']=(function(...)
require"common.c4_driver_declarations"
require"common.c4_property"
function OnDriverInit()
gInitializingDriver=true
print("INIT_CODE: OnDriverInit()")
for e,t in pairs(ON_DRIVER_EARLY_INIT)do
if(ON_DRIVER_EARLY_INIT[e]~=nil and type(ON_DRIVER_EARLY_INIT[e])=="function")then
print("INIT_CODE: ON_DRIVER_EARLY_INIT."..e.."()")
local t,e=pcall(ON_DRIVER_EARLY_INIT[e])
if(not t)then
print("LUA_ERROR: "..e)
end
end
end
for e,t in pairs(ON_DRIVER_INIT)do
if(ON_DRIVER_INIT[e]~=nil and type(ON_DRIVER_INIT[e])=="function")then
print("INIT_CODE: ON_DRIVER_INIT."..e.."()")
local e,t=pcall(ON_DRIVER_INIT[e])
if(not e)then
print("LUA_ERROR: "..t)
end
end
end
for e,t in pairs(Properties)do
print("INIT_CODE: Calling OnPropertyChanged - "..e..": "..t)
local t,e=pcall(OnPropertyChanged,e)
if(not t)then
print("LUA_ERROR: "..e)
end
end
gInitializingDriver=false
end
function OnDriverLateInit()
C4:ErrorLog("INIT_CODE: OnDriverLateInit()")
for e,t in pairs(ON_DRIVER_LATEINIT)do
if(ON_DRIVER_LATEINIT[e]~=nil and type(ON_DRIVER_LATEINIT[e])=="function")then
C4:ErrorLog("INIT_CODE: ON_DRIVER_LATEINIT."..e.."()")
ON_DRIVER_LATEINIT[e]()
end
end
end
function OnDriverDestroyed()
C4:ErrorLog("INIT_CODE: OnDriverDestroyed()")
for e,t in pairs(ON_DRIVER_DESTROYED)do
if(ON_DRIVER_DESTROYED[e]~=nil and type(ON_DRIVER_DESTROYED[e])=="function")then
C4:ErrorLog("INIT_CODE: ON_DRIVER_DESTROYED."..e.."()")
ON_DRIVER_DESTROYED[e]()
end
end
end end)
package.preload['common.c4_property']=(function(...)
require"common.c4_driver_declarations"
function OnPropertyChanged(e)
local i=Properties[e]
if(LOG~=nil and type(LOG)=="table")then
LogTrace("OnPropertyChanged("..e..") changed to: "..Properties[e])
end
local a=string.gsub(e," ","")
local t=true
local o=""
if(ON_PROPERTY_CHANGED[e]~=nil and type(ON_PROPERTY_CHANGED[e])=="function")then
t,o=pcall(ON_PROPERTY_CHANGED[e],i)
elseif(ON_PROPERTY_CHANGED[a]~=nil and type(ON_PROPERTY_CHANGED[a])=="function")then
t,o=pcall(ON_PROPERTY_CHANGED[a],i)
end
if(not t)then
LogError("LUA_ERROR: "..o)
end
end
function UpdateProperty(e,t)
if(Properties[e]~=nil)then
C4:UpdateProperty(e,t)
end
end
end)
package.preload['common.c4_command']=(function(...)
require"common.c4_driver_declarations"
function ExecuteCommand(e,a)
LogTrace("ExecuteCommand("..e..")")
LogInfo(a)
local o=string.gsub(e," ","")
local t,i
if(EX_CMD[e]~=nil and type(EX_CMD[e])=="function")then
t,i=pcall(EX_CMD[e],a)
elseif(EX_CMD[o]~=nil and type(EX_CMD[o])=="function")then
t,i=pcall(EX_CMD[o],a)
elseif(EX_CMD[e]~=nil)then
QueueCommand(EX_CMD[e])
t=true
else
LogInfo("ExecuteCommand: Unhandled command = "..e)
t=true
end
if(not t)then
LogError("LUA_ERROR: "..i)
end
end
function EX_CMD.LUA_ACTION(e)
if(e~=nil)then
for t,e in pairs(e)do
if(t=="ACTION"and e~=nil)then
local t,e=pcall(LUA_ACTION[e])
if(not t)then
LogError("LUA_ERROR: "..e)
end
else
LogInfo("Undefined Command")
LogInfo("Key: "..t.." Value: "..e)
end
end
end
end
function ReceivedFromProxy(a,e,t)
if(e~=nil)then
if(t==nil)then
t={}
end
LogTrace("ReceivedFromProxy(): "..e.." on binding "..a.."; Call Function PRX_CMD."..e.."()")
LogInfo(t)
if((PRX_CMD[e])~=nil)then
local t,e=pcall(PRX_CMD[e],a,t)
if(not t)then
LogError("LUA_ERROR: "..e)
end
else
LogInfo("ReceivedFromProxy: Unhandled command = "..e)
end
end
end end)
package.preload['common.c4_notify']=(function(...)
require"common.c4_driver_declarations"
function SendNotify(e,t,a)
C4:SendToProxy(a,e,t,"NOTIFY")
end
function SendSimpleNotify(e,...)
bindingID=select(1,...)or DEFAULT_PROXY_BINDINGID
C4:SendToProxy(bindingID,e,{},"NOTIFY")
end end)
package.preload['common.c4_utils']=(function(...)
if(TEMPLATE_VERSION~=nil)then
TEMPLATE_VERSION.c4_utils="2014.10.31"
end
function AsciiToBCD(t)
local e=0
local a=""
local o=false
local i=((#t%2)==0)and(t)or("0"..t)
for t=1,#i do
local t=tonumber(i:sub(t,t))
e=bit.lshift(e,4)+t
if(o)then
a=a..string.char(e)
e=0
end
o=(not o)
end
return a
end
function BCDToAscii(e)
return tostring(bit.rshift(e,4))..tostring(bit.band(e,15))
end
function MakeXMLNode(e,t)
return"<"..e..">"..t.."</"..e..">"
end
function MakeXMLAttrNode(e,t,o,a)
return"<"..e.." "..o.."=\""..a.."\">"..t.."</"..e..">"
end
function StringFromUnicode(t)
local e=""
for a=2,#t,2 do
e=e..string.sub(t,a,a)
end
return e
end
function StringSplit(a)
local e=" "
local t={}
for e in(a..e):gmatch("(.-)"..e)do
table.insert(t,e)
end
return t
end
function toboolean(e)
return(e==true or string.lower(e)=="true")
end
function Go(e,t,...)
if(type(e)=="function")then
return e(...)
else
LogTrace(t)
end
end
function IsEmpty(e)
return e==nil or e==""
end end)
package.preload['lib.c4_log']=(function(...)
require"common.c4_driver_declarations"
require"lib.c4_object"
c4_log=inheritsFrom(nil)
function c4_log:construct(e)
self._logLevel=5
self._outputPrint=Properties['Debug']=="On"
self._outputC4Log=false
self._logName=e or""
end
function c4_log:SetLogLevel(e)
self._logLevel=tonumber(string.sub(e or"",1,1))or self._logLevel
end
function c4_log:LogLevel()
return self._logLevel
end
function c4_log:OutputPrint(e)
self._outputPrint=e
end
function c4_log:OutputC4Log(e)
self._outputC4Log=e
end
function c4_log:SetLogName(e)
if(e==nil or e=="")then
e=""
else
e=e..": "
end
self._logName=e
end
function c4_log:LogName()
return self._logName
end
function c4_log:Enabled()
return(self._outputPrint or self._outputC4Log)
end
function c4_log:PrintEnabled()
return self._outputPrint
end
function c4_log:C4LogEnabled()
return self._outputC4Log
end
function c4_log:CreateTableText(t,e)
e=e or""
if(type(t)=="table")then
e=e.."{"
for a,t in pairs(t)do
if(type(a)=="number")then
e=e.."["..tostring(a).."]="
elseif(type(a)=="string")then
e=e..a.."="
else
print(tostring(a)..": "..tostring(t))
end
if(type(t)=="number")then
e=e..tostring(t)..","
elseif(type(t)=="string")then
e=e.."'"..t.."',"
elseif(type(t)=="table")then
e=c4_log:CreateTableText(t,e)
e=e..","
elseif(type(t)=="boolean")then
e=e..tostring(t)..","
end
end
e=e.."}"
end
return e
end
function InsertIndent(t)
local e=""
for t=1,t do
e=e.."\t"
end
return e
end
function c4_log:CreateTableTextFormatted(a,e,t)
e=e or""
t=t or 0
if(type(a)=="table")then
t=t+1
e=e.."{\n"
for o,a in pairs(a)do
if(type(o)=="number")then
e=e..InsertIndent(t).."["..tostring(o).."]="
elseif(type(o)=="string")then
e=e..InsertIndent(t)..o.."="
else
print(tostring(o)..": "..tostring(a))
end
if(type(a)=="number")then
e=e..tostring(a)..",\n"
elseif(type(a)=="string")then
e=e.."'"..a.."',\n"
elseif(type(a)=="table")then
e=c4_log:CreateTableTextFormatted(a,e,t)
e=e..",\n"
elseif(type(a)=="boolean")then
e=e..tostring(a)..",\n"
end
end
t=t-1
e=e..InsertIndent(t).."}"
end
return e
end
MAX_TABLE_LEVELS=10
function c4_log:PrintTable(t,e,a)
a=a+1
if(a<=MAX_TABLE_LEVELS)then
if(type(t)=="table")then
if(self._outputPrint)then
for o,t in pairs(t)do
print(e..tostring(o)..":  "..tostring(t))
if(type(t)=="table")then
self:PrintTable(t,e.."   ",a)
end
end
end
if(self._outputC4Log)then
for o,t in pairs(t)do
C4:ErrorLog(self._logName..": "..e..tostring(o)..":  "..tostring(t))
if(type(t)=="table")then
self:PrintTable(t,e.."   ",a)
end
end
end
else
if(self._outputPrint)then
print(e..t)
end
if(self._outputC4Log)then
C4:ErrorLog(self._logName..": "..e..t)
end
end
end
end
function c4_log:Print(t,e)
if(self._logLevel>=t)then
if(type(e)=="table")then
self:PrintTable(e,"   ",0)
return
end
if(self._outputPrint)then
print(e)
end
if(self._outputC4Log)then
C4:ErrorLog(self._logName..": "..e)
end
end
end
function c4_log:Fatal(e)
self:Print(0,e)
end
function c4_log:Error(e)
self:Print(1,e)
end
function c4_log:Warn(e)
self:Print(2,e)
end
function c4_log:Info(e)
self:Print(3,e)
end
function c4_log:Debug(e)
self:Print(4,e)
end
function c4_log:Trace(e)
self:Print(5,e)
end
function c4_log:LogOutput(t,e,...)
if(LogEnabled())then
if(type(e)=="string")then
e=string.format(e,...)
end
self:Print(t,e)
end
end
function SetLogLevel(e)
LOG:SetLogLevel(e)
end
function LogLevel()
return LOG:LogLevel()
end
function OutputPrint(e)
LOG:OutputPrint(e)
end
function OutputC4Log(e)
LOG:OutputC4Log(e)
end
function SetLogName(e)
LOG:SetLogName(e)
end
function LogName()
return LOG:LogName()
end
function LogEnabled()
return LOG:Enabled()
end
function PrintEnabled()
return LOG:PrintEnabled()
end
function C4LogEnabled()
return LOG:C4LogEnabled()
end
function tryLog(e,t,...)
LOG:LogOutput(e,t,...)
end
function LogFatal(e,...)
local e,t=pcall(tryLog,0,e,...)
if(not e)then
LOG:Print(1,"LUA_ERROR - LogFatal failed: "..t)
end
end
function LogError(e,...)
local t,e=pcall(tryLog,1,e,...)
if(not t)then
LOG:Print(1,"LUA_ERROR - LogError failed: "..e)
end
end
function LogWarn(e,...)
local t,e=pcall(tryLog,2,e,...)
if(not t)then
LOG:Print(1,"LUA_ERROR - LogWarn failed: "..e)
end
end
function LogInfo(e,...)
local t,e=pcall(tryLog,3,e,...)
if(not t)then
LOG:Print(1,"LUA_ERROR - LogInfo failed: "..e)
end
end
function LogDebug(e,...)
local t,e=pcall(tryLog,4,e,...)
if(not t)then
LOG:Print(1,"LUA_ERROR - LogDebug failed: "..e)
end
end
function LogTrace(e,...)
local e,t=pcall(tryLog,5,e,...)
if(not e)then
LOG:Print(1,"LUA_ERROR - LogTrace failed: "..t)
end
end
function dbgPrint(e)
if(LOG:PrintEnabled())then
print(e)
end
end
function dbgHexdump(e)
hexdump(e,dbgPrint)
end
function __test_c4_log()
require"test.C4Virtual"
local e=c4_log:new("test_c4_log")
assert(e:LogName()=="test_c4_log","_logName is not equal to 'test_c4_log' it is: "..e:LogName())
e:SetLogLevel("2 - Warning")
assert(e:LogLevel()==2,"_logLevel is not equal to '2' it is: "..e:LogLevel())
e:SetLogLevel(3)
assert(e:LogLevel()==3,"_logLevel is not equal to '3' it is: "..e:LogLevel())
e:OutputPrint(false)
assert(e:PrintEnabled()==false,"_outputPrint is not equal to 'false' it is: "..tostring(e:PrintEnabled()))
e:OutputC4Log(true)
assert(e:C4LogEnabled()==true,"_outputC4Log is not equal to 'true' it is: "..tostring(e:C4LogEnabled()))
e:SetLogLevel(4)
LogTrace("***** This is a test *****")
end
function __test_CreatTableText()
local e={}
e[1]={}
e[2]={}
e[3]=30
e[4]="Forty"
LogTrace("----- tText -----")
LogTrace(e)
local e={One={},
Two={},
Three=30,
Four="Forty"}
LogTrace("----- tText2 -----")
LogTrace(e)
local e={[1]={},
[2]={},
[3]=30,
[4]="Forty"}
LogTrace("----- tText3 -----")
LogTrace(e)
local e={[1]={},
Two={},
[3]=30,
[4]="Forty",
Five="Fifty"}
LogTrace("----- tText4 -----")
LogTrace(e)
local e=LOG:CreateTableText(e)
LogTrace("----- tableText -----")
LogTrace(e)
end
function __TestCreateTableTextFormatted()
require"test.C4Virtual"
local t=c4_log:new("test_c4_log")
local e={
Name='heat',
Attributes={},
ChildNodes={
[1]={
Name='button',
Attributes={},
ChildNodes={
[1]={
Value='51',
Attributes={},
Name='id',
ChildNodes={},
},
[2]={
Value='Pool Heater',
Attributes={},
Name='button_text',
ChildNodes={},
},
[3]={
Value='POOLHT',
Attributes={},
Name='button_name',
ChildNodes={},
},
},
},
[2]={
Name='button',
Attributes={},
ChildNodes={
[1]={
Value='53',
Attributes={},
Name='id',
ChildNodes={},
},
[2]={
Value='Spa Heater',
Attributes={},
Name='button_text',
ChildNodes={},
},
[3]={
Value='SPAHT',
Attributes={},
Name='button_name',
ChildNodes={},
},
},
},
[3]={
Name='button',
Attributes={},
ChildNodes={
[1]={
Value='54',
Attributes={},
Name='id',
ChildNodes={},
},
[2]={Value='Pool Solar Heater',
Attributes={},
Name='button_text',
ChildNodes={}
},
[3]={
Value='SOLHT',
Attributes={},
Name='button_name',
ChildNodes={},
},
}
}
}
}
print(t:CreateTableTextFormatted(e))
end end)
package.preload['lib.c4_object']=(function(...)
if(TEMPLATE_VERSION~=nil)then
TEMPLATE_VERSION.c4_object="2014.10.31"
end
function inheritsFrom(a)
local e={}
local t={__index=e}
function e:create(...)
local e={}
setmetatable(e,t)
if e.construct then
e=e:construct(...)or e
end
return e
end
if nil~=a then
setmetatable(e,{__index=a})
end
function e:class()
return e
end
function e:superClass()
return a
end
function e:super()
local t={}
t.child=self
t.parent=a
local a={}
a.__index=function(e,t)
if e.parent[t]then
return e.parent[t]
else
return e.child[t]
end
end
a.__newindex=function(e,t,o)
e.child[t]=o
end
a.__tostring=function(e)
return tostring(e.child)
end
setmetatable(t,a)
return t
end
e.new=e.create
function e:isa(a)
local t=false
local e=e
while(nil~=e)and(false==t)do
if e==a then
t=true
else
e=e:superClass()
end
end
return t
end
return e
end
function __test_inheritance()
local t=inheritsFrom(nil)
t.construct=function(e,t)
e._msg=t
end
local e=inheritsFrom(t)
e.construct=function(t,e)
t:super():construct(e)
end
t1=e:new("t1")
t2=e:new("t2")
assert(t1._msg=="t1","t1 message is not equal to 't1' it''s: "..t1._msg)
assert(t2._msg=="t2","t2 message is not equal to 't2' it''s: "..t2._msg)
assert(tostring(t1:super())==tostring(t1),"tostrings don't match");
assert(t1:superClass()==t,"superClass and baseClass should be the same. They are not.")
t1:superClass().id="parent"
assert(t1.id=="parent","obect''s super class has invalid property value: ",t1.id)
t1.id="child"
assert(t1.id=="child","object instance variable has invalid property value: "..t1.id)
assert(t1:super().id=="parent","superAsSelf found invalid value for base class variable")
t1:super().id="child1"
assert(t1:super().id=="parent","Setting of instance variable hid base classes variable from itself");
assert(t1.id=="child1","Settings of instance variable did not change child instance variable")
end end)
package.preload['lib.c4_timer']=(function(...)
require"common.c4_driver_declarations"
require"lib.c4_object"
if(TEMPLATE_VERSION~=nil)then
TEMPLATE_VERSION.c4_timer="2014.10.31"
end
c4_timer=inheritsFrom(nil)
function c4_timer:construct(i,t,a,o,n,e)
self._name=i
self._timerID=TimerLibGetNextTimerID()
self._interval=t
self._units=a
self._repeating=n or false
self._Callback=o
self._CallbackParam=e or""
self._id=0
gTimerLibTimers[self._timerID]=self
if(LOG~=nil and type(LOG)=="table")then
LogTrace("Created timer "..self._name)
end
end
function c4_timer:StartTimer(...)
c4_timer:KillTimer()
if...then
local a=select(1,...)
local e=select(2,...)
local t=select(3,...)
self._interval=a or self._interval
self._units=e or self._units
self._repeating=t or self._repeating
end
if(self._interval>0)then
if(LOG~=nil and type(LOG)=="table")then
LogTrace("Starting Timer: "..self._name)
end
self._id=C4:AddTimer(self._interval,self._units,self._repeating)
end
end
function c4_timer:KillTimer()
if(self._id)then
self._id=C4:KillTimer(self._id)
end
end
function c4_timer:TimerStarted()
return(self._id~=0)
end
function c4_timer:TimerStopped()
return(self._id==0)
end
function c4_timer:GetTimerInterval()
return(self._interval)
end
function TimerLibGetNextTimerID()
gTimerLibTimerCurID=gTimerLibTimerCurID+1
return gTimerLibTimerCurID
end
function ON_DRIVER_EARLY_INIT.c4_timer()
gTimerLibTimers={}
gTimerLibTimerCurID=0
end
function ON_DRIVER_DESTROYED.c4_timer()
for t,e in pairs(gTimerLibTimers)do
e:KillTimer()
end
end
function OnTimerExpired(t)
for a,e in pairs(gTimerLibTimers)do
if(t==e._id)then
if(e._Callback)then
e._Callback(e._CallbackParam)
end
end
end
end
end)
package.preload['lib.c4_xml']=(function(...)
if(TEMPLATE_VERSION~=nil)then
TEMPLATE_VERSION.c4_xml="2014.10.31"
end
function GetParsedXmlNode(e,t)
for a,e in pairs(e["ChildNodes"])do
if(e["Name"]==t)then
return e["ChildNodes"]
end
end
return nil
end
function GetParsedXmlValuesByKey(e,t,n,o)
local a={}
o=o or false
for e,i in pairs(e)do
if(i["Name"]==t)then
local e
for i,t in pairs(i["ChildNodes"])do
if(t["Name"]==n)then
if(o==true)then
e=tonumber(t.Value)
else
e=tostring(t.Value)
end
break
end
end
a[e]={}
for o,t in pairs(i["ChildNodes"])do
if(t["Name"]~=n)then
a[e][t.Name]=t.Value
end
end
end
end
return a
end
function GetParsedXmlVaulesByKeyAttribute(e,a,i,t)
local o={}
t=t or false
for n,e in pairs(e["ChildNodes"])do
if(e["Name"]==a)then
local a
if(t==true)then
a=tonumber(e["Attributes"][i])
else
a=e["Attributes"][i]
end
o[a]=e["Value"]
end
end
return o
end
function BuildSimpleXml(t,a,o)
local e=""
if(t~=nil)then
e="<"..t..">"
end
for a,t in pairs(a)do
e=e.."<"..a
if(type(t)=="table")then
for t,a in pairs(t.attributes)do
e=e..' '..t..'=\"'..a..'\"'
end
e=e..">"..InsertValue(t.value,o).."</"..a..">"
else
e=e..">"..InsertValue(t,o).."</"..a..">"
end
end
if(t~=nil)then
e=e.."</"..t..">"
end
return e
end
function InsertValue(e,t)
if(t)then
e=C4:XmlEscapeString(tostring(e))
end
return e
end
function StartElement(e)
return"<"..e..">"
end
function EndElement(e)
return"</"..e..">"
end
function AddElement(e,t)
LogTrace("tag = "..e)
LogTrace("data = "..t)
return"<"..e..">"..t.."</"..e..">"
end
end)
package.preload['panel_proxy.securitypanel']=(function(...)
TEMPLATE_VERSION.securitypanel="6"
function ON_DRIVER_LATEINIT.PANELINIT()
local e=
[[<partitions>
		<partition>
			<id>1</id>
			<enabled>true</enabled>
			<binding_id>5002</binding_id>
			<state>DISARMED_READY</state>
		</partition>
	</partitions>]]
NOTIFY.ALL_PARTITIONS_INFO(e,5001)
C4:SendToProxy(5002,"PARTITION_ENABLED",{ENABLED="true"},"NOTIFY")
C4:SendToProxy(5002,"PARTITION_STATE_INIT",{STATE="DISARMED_READY",TYPE=""},"NOTIFY")
end
function ON_DRIVER_INIT.PANELINIT()
ZONES=C4:PersistGetValue("ZONES")or{}
PGMS=C4:PersistGetValue("PGMS")or{}
end
function getAllPartitionXML()
local e=
[[<partitions>
		<partition>
			<id>1</id>
			<enabled>true</enabled>
			<binding_id>5002</binding_id>
			<state>%s</state>
		</partition>
	</partitions>]]
e=string.format(e,PART_STATE)
return e
end
function getAllZonesInfoXML()
local e="<zones>"
local a=[[
		<zone>
			<id>%s</id>
			<name>%s</name>
			<type_id>0</type_id>
			<partitions>1</partitions>
			<can_bypass>false</can_bypass>
			<is_open>%s</is_open>
		</zone>
	]]
for o,t in pairs(ZONES)do
if t.id~=getIDFromProperty(Properties["Arm/Disarm Status (Contact)"])and
t.id~=getIDFromProperty(Properties["Alarm Triggered Status (Contact)"])then
e=e..string.format(a,t.id,t.name,ZONES_STATE[t.id]or"false")
end
end
e=e.."</zones>"
return e
end
function getAllPGMInfoXML()
local e="<pgms>"
local a=[[
		<pgm>
			<id>%s</id>
			<is_open>%s</is_open>
		</pgm>
	]]
for o,t in pairs(PGMS)do
if(t.id~=getIDFromProperty(Properties["Arm/Disarm (Relay)"]))then
e=e..string.format(a,t.id,PGMS_STATE[t.id]or"false")
end
end
e=e.."</pgms>"
return e
end
end)
package.preload['panel_proxy.securitypanel_notifies']=(function(...)
require"common.c4_notify"
TEMPLATE_VERSION.securitypanel="6"
function NOTIFY.PANEL_ZONE_STATE(t,a,o)
local e={}
LogTrace("NOTIFY.PANEL_ZONE_STATE: %d %s %d",tonumber(t),tostring(a),tonumber(o))
e["ZONE_ID"]=t
e["ZONE_OPEN"]=a
SendNotify("PANEL_ZONE_STATE",e,o)
end
function NOTIFY.PANEL_PGM_STATE(t,a,o)
local e={}
LogTrace("NOTIFY.PANEL_PGM_STATE: %d %s %d",tonumber(t),tostring(a),tonumber(o))
e["PGM_ID"]=t
e["PGM_OPEN"]=a
SendNotify("PANEL_PGM_STATE",e,o)
end
function NOTIFY.PANEL_ADD_PGM(a,e)
local t={}
LogTrace("NOTIFY.PANEL_ADD_PGM: %d %d",tonumber(a),tonumber(e))
t["ID"]=a
SendNotify("PANEL_ADD_PGM",t,e)
end
function NOTIFY.PANEL_REMOVE_PGM(a,t)
local e={}
LogTrace("NOTIFY.PANEL_REMOVE_PGM: %d %d",tonumber(a),tonumber(t))
e["ID"]=a
SendNotify("PANEL_REMOVE_PGM",e,t)
end
function NOTIFY.PANEL_PARTITION_STATE(t,a,o,i)
local e={}
LogTrace("NOTIFY.PANEL_PARTITION_STATE: %d %s %s %d",tonumber(t),tostring(a),tostring(o),tonumber(i))
e["PARTITION_ID"]=t
e["STATE"]=a
e["TYPE"]=o
SendNotify("PANEL_PARTITION_STATE",e,i)
end
function NOTIFY.PANEL_ZONE_INFO(t,o,a,n,s,i)
local e={}
LogTrace("NOTIFY.PANEL_ZONE_INFO: %d %s %d %d",tonumber(t),tostring(o),tonumber(a),tonumber(i))
e["ID"]=t
e["NAME"]=o
e["TYPE_ID"]=a
e["PARTITIONS"]=n
e["IS_OPEN"]=tostring(s)
SendNotify("PANEL_ZONE_INFO",e,i)
end
function NOTIFY.PANEL_REMOVE_ZONE(a,e)
local t={}
LogTrace("NOTIFY.PANEL_REMOVE_ZONE: %d %d",tonumber(a),tonumber(e))
t["ID"]=a
SendNotify("PANEL_REMOVE_ZONE",t,e)
end
function NOTIFY.TROUBLE_START(a,t,o)
local e={}
LogTrace("NOTIFY.TROUBLE_START: %s %s %d",tostring(a),tostring(t),tonumber(o))
e["TROUBLE_TEXT"]=a
e["IDENTIFIER"]=t
SendNotify("TROUBLE_START",e,o)
end
function NOTIFY.TROUBLE_CLEAR(t,e)
local a={}
LogTrace("NOTIFY.TROUBLE_CLEAR: %s %d",tostring(t),tonumber(e))
a["IDENTIFIER"]=t
SendNotify("TROUBLE_CLEAR",a,e)
end
function NOTIFY.ALL_PARTITIONS_INFO(e,t)
SendNotify("ALL_PARTITIONS_INFO",e,t)
end
function NOTIFY.ALL_ZONES_INFO(e,t)
LogTrace(e)
SendNotify("ALL_ZONES_INFO",e,t)
end
function NOTIFY.ALL_PGMS_INFO(e,t)
LogTrace(e)
SendNotify("ALL_PGMS_INFO",e,t)
end
end)
package.preload['panel_proxy.securitypanel_commands']=(function(...)
require"common.c4_command"
require"common.c4_utils"
TEMPLATE_VERSION.securitypanel="6"
function PRX_CMD.GET_PANEL_SETUP(e,e)
SendNotify("ALL_PARTITIONS_INFO",getAllPartitionXML(),5001)
SendNotify("ALL_ZONES_INFO",getAllZonesInfoXML(),5001)
SendNotify("ALL_PGMS_INFO",getAllPGMInfoXML(),5001)
end
function PRX_CMD.GET_ALL_PARTITION_INFO(e,e)
SendNotify("ALL_PARTITIONS_INFO",getAllPartitionXML(),5001)
end
function PRX_CMD.GET_ALL_ZONE_INFO(e,e)
SendNotify("ALL_ZONES_INFO",getAllZonesInfoXML(),5001)
end
function PRX_CMD.GET_ALL_PGM_INFO(e,e)
SendNotify("ALL_PGMS_INFO",getAllPGMInfoXML(),5001)
end
function PRX_CMD.SET_PANEL_TIME_DATE(e,e)
end
function PRX_CMD.SET_PARTITION_ENABLED(e,e)
end
function PRX_CMD.SEND_PGM_COMMAND(t,e)
local t=tonumber(e.PGM_ID)
local e=e.COMMAND
end
function PRX_CMD.SET_ZONE_INFO(t,e)
local t=tonumber(e.ZONE_ID)
local t=e.NAME
local e=tonumber(e.TYPE_ID)
end
function PRX_CMD.EVENT(t,e)
local t=tonumber(e.ZONE)
local a=e.STATE
if ZONES[t]then
if(ALARM_STATE==t)then
if a==0 then
NOTIFY.PANEL_PARTITION_STATE(1,"ARMED","",5001)
NOTIFY.PARTITION_STATE("ARMED","",0,0,5002,true)
else
NOTIFY.PANEL_PARTITION_STATE(1,"DISARMED_READY","",5001)
NOTIFY.PARTITION_STATE("DISARMED_READY","",0,0,5002,false)
end
elseif(ALARM_TRIGGERED==t)then
if a==0 then
NOTIFY.PANEL_PARTITION_STATE(1,"ALARM","",5001)
NOTIFY.PARTITION_STATE("ALARM","",0,0,5002,true)
else
if ZONES_STATE[ALARM_STATE]=="1"then
NOTIFY.PANEL_PARTITION_STATE(1,"ARMED","",5001)
NOTIFY.PARTITION_STATE("ARMED","",0,0,5002,true)
else
NOTIFY.PANEL_PARTITION_STATE(1,"DISARMED_READY","",5001)
NOTIFY.PARTITION_STATE("DISARMED_READY","",0,0,5002,false)
end
end
else
local e={}
e["ZONE_ID"]=t
e["ZONE_OPEN"]="False"
if(a=='1')then
e["ZONE_OPEN"]="True"
end
e["ZONE_BYPASSED"]=tostring(false)
SendNotify("ZONE_STATE",e,5002)
SendNotify("PANEL_ZONE_STATE",e,5001)
end
elseif PGMS[t]then
if(Properties["Arm/Disarm (Relay)"]==PGMS[t].name)then
end
end
end
function PRX_CMD.CURRENT_CONFIG(t,e)
local t=e.CONFIG
if(type(e.CONFIG)=='string')then
t=C4:JsonDecode(e.CONFIG)
end
local a={}
local o={}
for t,e in pairs(t)do
if(tonumber(t))then
if e.zoneType=="sensor"then
a[e.id]=e
elseif e.zoneType=="relay"then
o[e.id]=e
end
end
end
UpdateZones(a)
UpdatePGMs(o)
PersistAllTheThings()
end
function PersistAllTheThings()
C4:PersistSetValue("ZONES",ZONES)
C4:PersistSetValue("PGMS",PGMS)
end
function UpdateZones(e)
for t,a in pairs(ZONES)do
if not e[t]then
ZONES[t]=nil
end
end
for e,t in pairs(e)do
ZONES[e]=t
end
UpdateZonesInProxy()
UpdateDynamicLists()
end
function UpdateZonesInProxy()
SendNotify("ALL_ZONES_INFO",getAllZonesInfoXML(),5001)
for t,e in pairs(ZONES)do
if e.id~=getIDFromProperty(Properties["Arm/Disarm Status (Contact)"])and
e.id~=getIDFromProperty(Properties["Alarm Triggered Status (Contact)"])then
SendNotify("HAS_ZONE",{ZONE_ID=e.id},5002)
end
end
end
function UpdatePGMs(e)
for t,a in pairs(PGMS)do
if not e[t]then
PGMS[t]=nil
end
end
for e,t in pairs(e)do
PGMS[e]=t
end
UpdatePGMSInProxy()
UpdateDynamicLists()
end
function UpdatePGMSInProxy()
SendNotify("ALL_PGMS_INFO",getAllPGMInfoXML(),5001)
end
function getIDFromProperty(e)
local t,t,e=string.find(e,"(%d+).*")
if e then
return tonumber(e)
else
return-1
end
end
function UpdateDynamicLists()
local a="Please Select A Zone..."
local s="Please Select A Zone..."
local o="Please Select A Zone..."
local n="Please Select A Zone..."
local t
local i="Please Select A Zone..."
for o,e in pairs(ZONES)do
t=Properties["Arm/Disarm Status (Contact)"]
a=a..","..e.id.." - "..e.name
if(e.id==getIDFromProperty(t))then
s=e.id.." - "..e.name
end
t=Properties["Alarm Triggered Status (Contact)"]
if(e.id==getIDFromProperty(t))then
i=e.id.." - "..e.name
end
end
for a,e in pairs(PGMS)do
t=Properties["Arm/Disarm (Relay)"]
o=o..","..e.id.." - "..e.name
if(e.id==getIDFromProperty(t))then
n=e.id.." - "..e.name
end
end
C4:UpdatePropertyList("Arm/Disarm Status (Contact)",a,s)
C4:UpdatePropertyList("Alarm Triggered Status (Contact)",a,i)
C4:UpdatePropertyList("Arm/Disarm (Relay)",o,n)
end
end)
package.preload['panel_proxy.pgm_info']=(function(...)
require"lib.c4_object"
require"panel_proxy.relay_notifies"
TEMPLATE_VERSION.securitypanel="6"
PgmInfoList={}
PgmInformation=inheritsFrom(nil)
function PgmInformation:construct(e)
self._PgmID=e
self._IsOpen=false
self._NeedToSendInitialInfo=true
PgmInfoList[e]=self
end
function PgmInformation:destruct()
PgmInfoList[self._PgmID]=nil
end
function PgmInformation:PgmXML()
local e={}
table.insert(e,MakeXMLNode("id",tostring(self._PgmID)))
table.insert(e,MakeXMLNode("is_open",tostring(self:GetPgmState())))
return MakeXMLNode("pgm",table.concat(e,"\n"))
end
function PgmInformation:SetPgmState(e,t)
local t=t or false
if((self._IsOpen~=e)or self._NeedToSendInitialInfo)then
self._IsOpen=e
if(not t)then
LogTrace("!!!!!!   Pgm %d %s  !!!!!!",tonumber(self._PgmID),tostring(self:GetPgmState()))
NOTIFY.PANEL_PGM_STATE(self._PgmID,self._IsOpen,TheSecurityPanel._BindingID)
self._NeedToSendInitialInfo=false
end
end
end
function PgmInformation:GetPgmState()
return self._IsOpen
end end)
package.preload['partition_proxy.securitypartition_functions']=(function(...)
TEMPLATE_VERSION.securitypartition="9"
function ArmPartitionFailed(e,t)
if(SecurityPartitionIndexList[tonumber(e)]~=nil)then
SecurityPartitionIndexList[tonumber(e)]:ArmFailed(t)
end
end
function DisarmPartitionFailed(e)
if(SecurityPartitionIndexList[tonumber(e)]~=nil)then
SecurityPartitionIndexList[tonumber(e)]:DisarmFailed()
end
end
function RequestKeypadInfo(e,a,i,o,t)
if(SecurityPartitionIndexList[tonumber(e)]~=nil)then
SecurityPartitionIndexList[tonumber(e)]:RequestKeypadInfo(a,i,o,t)
end
end
function GetPartitionZoneIDs(e)
if(SecurityPartitionIndexList[tonumber(e)]~=nil)then
return SecurityPartitionIndexList[tonumber(e)]:GetZoneIDs()
else
return nil
end
end
function GetPartitionZoneCount(e)
if(SecurityPartitionIndexList[tonumber(e)]~=nil)then
return SecurityPartitionIndexList[tonumber(e)]:GetZoneCount()
else
return 0
end
end
function AddZoneToPartition(t,e)
if(SecurityPartitionIndexList[tonumber(t)]~=nil)then
if(ZoneInfoList[tonumber(e)]==nil)then
ZoneInformation:new(tonumber(e))
end
SecurityPartitionIndexList[tonumber(t)]:AddZone(tonumber(e))
ZoneInfoList[tonumber(e)]:AddToPartition(tonumber(t))
end
end
function RemoveZoneFromPartition(e,t)
if(SecurityPartitionIndexList[tonumber(e)]~=nil)then
SecurityPartitionIndexList[tonumber(e)]:RemoveZone(tonumber(t))
if(ZoneInfoList[tonumber(t)]~=nil)then
ZoneInfoList[tonumber(t)]:RemoveFromPartition(tonumber(e))
end
end
end
function SetPartitionEnabled(e,t)
if(SecurityPartitionIndexList[tonumber(e)]~=nil)then
SecurityPartitionIndexList[tonumber(e)]:SetEnabled(t)
end
end
function IsPartitionEnabled(e)
if(SecurityPartitionIndexList[tonumber(e)]~=nil)then
return SecurityPartitionIndexList[tonumber(e)]:IsEnabled()
else
return false
end
end
function SetPartitionState(a,o,t,e)
if(SecurityPartitionIndexList[tonumber(a)]~=nil)then
t=t or""
e=tonumber(e)or 0
SecurityPartitionIndexList[tonumber(a)]:SetPartitionState(o,t,e)
end
end
function GetPartitionState(e)
if(SecurityPartitionIndexList[tonumber(e)]~=nil)then
return SecurityPartitionIndexList[tonumber(e)]:GetPartitionState()
else
return"DISARMED_NOT_READY"
end
end
function GetPartitionArmType(e)
if(SecurityPartitionIndexList[tonumber(e)]~=nil)then
return SecurityPartitionIndexList[tonumber(e)]:GetPartitionArmType()
else
return"UNKNOWN"
end
end
function SetCodeRequiredToArm(e,t)
if(SecurityPartitionIndexList[tonumber(e)]~=nil)then
SecurityPartitionIndexList[tonumber(e)]:SetCodeRequiredToArm(t)
end
end
function IsPartitionArmed(e)
if(SecurityPartitionIndexList[tonumber(e)]~=nil)then
return SecurityPartitionIndexList[tonumber(e)]:IsArmed()
else
return false
end
end
function IsPartitionInDelay(e)
if(SecurityPartitionIndexList[tonumber(e)]~=nil)then
return SecurityPartitionIndexList[tonumber(e)]:IsInDelay()
else
return false
end
end
function DisplayPartitionText(e,t)
if(SecurityPartitionIndexList[tonumber(e)]~=nil)then
SecurityPartitionIndexList[tonumber(e)]:DisplayText(t)
end
end
function HaveEmergency(e)
for a,t in pairs(SecurityPartitionIndexList)do
t:HaveEmergency(e)
end
end end)
package.preload['partition_proxy.securitypartition_commands']=(function(...)
require"lib.c4_log"
TEMPLATE_VERSION.securitypartition="9"
function PRX_CMD.KEY_PRESS(e,e)
LogTrace("PRX_CMD.KEY_PRESS")
end
function PRX_CMD.PARTITION_ARM(e,e)
LogTrace("PRX_CMD.PARTITION_ARM")
if(Properties["Arm/Disarm (Relay) Type"]=="Momentary")then
SendNotify("EVENT",{ZONE=ALARM_MODE,STATE=2,TIME=Properties["Arm/Disarm (Relay) Trigger Time"]},1)
else
SendNotify("EVENT",{ZONE=ALARM_MODE,STATE=1},1)
end
local t=tonumber(Properties["Exit Delay"])or 60
NOTIFY.PARTITION_STATE("EXIT_DELAY","",Properties["Exit Delay"],Properties["Exit Delay"],5002,false)
NOTIFY.PANEL_PARTITION_STATE(1,"EXIT_DELAY","",5001)
local e=function()
NOTIFY.PANEL_PARTITION_STATE(1,"ARMED","",5001)
NOTIFY.PARTITION_STATE("ARMED","",0,0,5002,true)
end
C4:SetTimer(t*1e3,e,false)
end
function PRX_CMD.PARTITION_DISARM(t,e)
LogTrace("PRX_CMD.PARTITION_DISARM")
if(e.UserCode==Properties["User Code"])then
if(Properties["Arm/Disarm (Relay) Type"]=="Momentary")then
SendNotify("EVENT",{ZONE=ALARM_MODE,STATE=2,TIME=Properties["Arm/Disarm (Relay) Trigger Time"]},1)
else
SendNotify("EVENT",{ZONE=ALARM_MODE,STATE=0},1)
end
NOTIFY.PANEL_PARTITION_STATE(1,"DISARMED_READY","",5001)
NOTIFY.PARTITION_STATE("DISARMED_READY","",0,0,5002,false)
else
NOTIFY.DISARM_FAILED(5002,e.InterfaceID)
end
end
function PRX_CMD.EXECUTE_EMERGENCY(e,e)
LogTrace("PRX_CMD.EXECUTE_EMERGENCY")
end
function PRX_CMD.EXECUTE_FUNCTION(e,e)
LogTrace("PRX_CMD.EXECUTE_FUNCTION")
end
function PRX_CMD.BYPASS_ZONE(e,e)
LogTrace("PRX_CMD.BYPASS_ZONE")
end
function PRX_CMD.GET_CURRENT_STATE(e,e)
LogTrace("PRX_CMD.GET_CURRENT_STATE")
end
end)
package.preload['partition_proxy.securitypartition_notifies']=(function(...)
require"common.c4_notify"
TEMPLATE_VERSION.securitypartition="9"
function NOTIFY.DISPLAY_TEXT(t,e)
local a={}
LogTrace("Sending Display Text on Binding %s: %s",tostring(e),tostring(t))
C4:SendToProxy(e,"DISPLAY_TEXT",t)
end
function NOTIFY.PARTITION_STATE(t,o,n,i,a,s)
local e={}
LogTrace("NOTIFY.PARTITION_STATE  %s  >>%s<<  %d %d %d",tostring(t),tostring(o),tonumber(n),tonumber(i),tonumber(a))
e["STATE"]=t
e["TYPE"]=o
e["DELAY_TIME_TOTAL"]=n
e["DELAY_TIME_REMAINING"]=i
e["CODE_REQUIRED_TO_CLEAR"]=s or false
SendNotify("PARTITION_STATE",e,a)
end
function NOTIFY.PARTITION_STATE_INIT(t,a,i,o,n)
local e={}
LogTrace("NOTIFY.PARTITION_STATE_INIT: %s %s %d %d %d",tostring(t),tostring(a),tonumber(i),tonumber(o),tonumber(n))
e["STATE"]=t
e["TYPE"]=a
e["DELAY_TIME_TOTAL"]=i
e["DELAY_TIME_REMAINING"]=o
SendNotify("PARTITION_STATE_INIT",e,n)
end
function NOTIFY.PARTITION_ENABLED(t,a)
local e={}
LogTrace("NOTIFY.PARTITION_ENABLED: %s %d",tostring(t),tonumber(a))
e["ENABLED"]=tostring(t)
SendNotify("PARTITION_ENABLED",e,a)
end
function NOTIFY.ZONE_STATE(o,a,t,i)
local e={}
LogTrace("NOTIFY.ZONE_STATE: %d %s %s %d",tonumber(o),tostring(a),tostring(t),tonumber(i))
e["ZONE_ID"]=tostring(o)
e["ZONE_OPEN"]=tostring(a)
e["ZONE_BYPASSED"]=tostring(t)
SendNotify("ZONE_STATE",e,i)
end
function NOTIFY.EMERGENCY_TRIGGERED(a,e)
local t={}
LogTrace("Sending EMERGENCY_TRIGGERED: >>%s<< on binding: %d",tostring(a),tonumber(e))
t["TYPE"]=a
SendNotify("EMERGENCY_TRIGGERED",t,e)
end
function NOTIFY.DISARM_FAILED(e,t)
LogTrace("NOTIFY.DISARM_FAILED: %d",tonumber(e))
SendNotify("DISARM_FAILED",{INTERFACE_ID=t},e)
end
function NOTIFY.ARM_FAILED(e,t)
local a={ACTION=e}
LogTrace("NOTIFY.ARM_FAILED: %s %d",tostring(e),tonumber(t))
SendNotify("ARM_FAILED",a,t)
end
function NOTIFY.REQUEST_KEYPAD_INFO(i,a,t,n,o)
local e={}
LogTrace("NOTIFY.REQUEST_KEYPAD_INFO: %s %s %s %d",tostring(i),tostring(a),tostring(t),tonumber(o))
e["PROMPT"]=t
e["DEVICE_ID"]=i
e["PARAMETERS"]=table.concat(n," ")
e["FUNCTION_NAME"]=a
SendNotify("REQUEST_KEYPAD_INFO",e,o)
end
function NOTIFY.HAS_ZONE(e,t)
local a={}
LogTrace("NOTIFY.HAS_ZONE: %d %d",tonumber(e),tonumber(t))
a["ZONE_ID"]=tostring(e)
SendNotify("HAS_ZONE",a,t)
end
function NOTIFY.REMOVE_ZONE(e,a)
local t={}
LogTrace("NOTIFY.REMOVE_ZONE: %d %d",tonumber(e),tonumber(a))
t["ZONE_ID"]=tostring(e)
SendNotify("REMOVE_ZONE",t,a)
end
function NOTIFY.CLEAR_ZONE_LIST(e)
LogTrace("NOTIFY.CLEAR_ZONE_LIST: %d",tonumber(e))
SendNotify("CLEAR_ZONE_LIST","",e)
end
function NOTIFY.CODE_REQUIRED(a,e)
local t={}
LogTrace("Sending CODE_REQUIRED: >>%s<< on binding: %d",tostring(a),tonumber(e))
t["CODE_REQUIRED_TO_ARM"]=tostring(a)
C4:SendToProxy(e,"CODE_REQUIRED",t)
end
function NOTIFY.PARTITION_INFO(t,e)
LogTrace("NOTIFY.PARTITION_INFO: %s %d",tostring(t),tonumber(e))
C4:SendToProxy(e,"PARTITION_INFO",t)
end
end)
package.preload['actions']=(function(...)
if(TEMPLATE_VERSION~=nil)then
TEMPLATE_VERSION.actions="2014.10.16"
end
function LUA_ACTION.TemplateVersion()
TemplateVersion()
end
function LUA_ACTION.DisplayGlobals()
end
end)
package.preload['properties']=(function(...)
if(TEMPLATE_VERSION~=nil)then
TEMPLATE_VERSION.properties="2014.10.13"
end
function ON_PROPERTY_CHANGED.CodeRequiredtoArm(e)
end
function ON_PROPERTY_CHANGED.KonnectedDevices(e)
local e=tonumber(e)or-1
local a=C4:GetBoundConsumerDevices(C4:GetDeviceID(),1)
if(a)then
local t=false
for a,o in pairs(a)do
if(tonumber(a)==e)then
t=true
else
C4:Unbind(a,1)
end
end
if(t==false)then
C4:Bind(C4:GetDeviceID(),1,e,1,"KONNECTED_ALARM_PANEL")
end
else
C4:Bind(C4:GetDeviceID(),1,e,1,"KONNECTED_ALARM_PANEL")
end
end
ON_PROPERTY_CHANGED["Arm/Disarm Status (Contact)"]=function(e)
local e=getIDFromProperty(e)
ARM_STATE=e
C4:SendToProxy(5001,"PANEL_REMOVE_ZONE",{ID=e},"NOTIFY")
C4:SendToProxy(5002,"REMOVE_ZONE",{ZONE_ID=e},"NOTIFY")
UpdateZonesInProxy()
end
ON_PROPERTY_CHANGED["Arm/Disarm (Relay)"]=function(e)
local e=getIDFromProperty(e)
ALARM_MODE=e
C4:SendToProxy(5001,"PANEL_REMOVE_PGM",{ID=e},"NOTIFY")
UpdatePGMSInProxy()
end
ON_PROPERTY_CHANGED["Alarm Triggered Status (Contact)"]=function(e)
local e=getIDFromProperty(e)
ALARM_TRIGGERED=e
C4:SendToProxy(5001,"PANEL_REMOVE_ZONE",{ID=e},"NOTIFY")
C4:SendToProxy(5002,"REMOVE_ZONE",{ZONE_ID=e},"NOTIFY")
UpdateZonesInProxy()
end
ON_PROPERTY_CHANGED["Arm/Disarm (Relay) Type"]=function(e)
if e=="Momentary"then
C4:SetPropertyAttribs("Arm/Disarm (Relay) Trigger Time",0)
else
C4:SetPropertyAttribs("Arm/Disarm (Relay) Trigger Time",1)
end
end
function UpdateProperty(e,t)
if(Properties[e]~=nil)then
C4:UpdateProperty(e,t)
end
end
end)
require"common.c4_driver_declarations"
require"common.c4_common"
require"common.c4_init"
require"common.c4_property"
require"common.c4_command"
require"common.c4_notify"
require"common.c4_utils"
require"panel_proxy.securitypanel"
require"panel_proxy.securitypanel_notifies"
require"panel_proxy.securitypanel_commands"
require"partition_proxy.securitypartition_commands"
require"partition_proxy.securitypartition_notifies"
require"actions"
require"properties"
DRIVER_NAME="C4SecuritySystemSimulator"
TEMPLATE_VERSION.security_system_template_version="2014.11.24"
ZONES={}
ZONES_STATE={}
PGMS={}
PGMS_STATE={}
PART_STATE="DISARMED_READY"
ALARM_MODE="-1"
ALARM_STATE="-1"
ALARM_TRIGGERED="-1"
PANEL_PROXY_BINDINGID=DEFAULT_PROXY_BINDINGID
BASE_PARTITION_PROXY_BINDINGID=DEFAULT_PROXY_BINDINGID+1
SERIAL_PORT_BINDINGID=1
PARTITION_ID_MAX=1
function ON_DRIVER_EARLY_INIT.MainDriver()
end
function ON_DRIVER_INIT.MainDriver()
end
function ON_DRIVER_LATEINIT.MainDriver()
OnPropertyChanged("Arm/Disarm (Relay) Type")
C4:UpdateProperty("Version","4")
end
function Initialize_SecuritySystem()
end
